#ifndef atomcommands_h
#define atomcommands_h
//Commands that Atomview uses for message passing
//Here because the message class needs it
const string CLASS_TYPE   = "fileController"; 
//Goto the next file
const string READNEXT     = "read_next"     ; 
//Goto the previous file
const string READPREVIOUS = "read_previous" ; 
//Read at a specific time
const string READTIME     = "read_time"     ; 
//Get the time that the simulator is at
const string GETTIME      = "get_time"      ; 
//What the current time is
const string TIMEIS       = "time_is"       ; 
//Read the current data set (refresh)
const string READCURR     = "read_current"  ; 
//Read the first data set
const string READFIRST    = "read_first"    ; 
//Goto the last file
const string READLAST     = "read_last"     ; 
//Start playing
const string PLAY         = "play"          ; 
//How many files per second to display
const string PLAYRATE     = "play_rate"     ; 
//How many writes per second
const string DATARATE     = "data_rate"     ; 
//Stop playing
const string STOP         = "stop"          ; 
//After playing is finished loop through it
const string LOOP         = "loop"          ; 
//Kill the program
const string DIE          = "die"           ; 
//Do nothing
const string NOTHING      = "nothing"       ; 
//Scale the model size
const string MODELSCALE	  = "modelscale"    ; 
//Set the number of polygons
const string NUMPOLY      = "numpolygons"   ; 
//Scale the world size
const string WORLDSCALE   = "worldscale"    ; 
//Commands for the playing of files
//Command for getting the Playrate, datarate, current position, and the ending position, 
//looping, worldscale rate, atomscale rate, scale on orgin, scale on current position
const string GETINFO      = "get_info"      ; 
//Command used to read the information from above				      
const string INFOIS       = "info_is"       ; 
//Start and stop commands for navigation
const string STOPNAV      = "stopnav"       ;
const string STARTNAV     = "startnav"      ;
//Updating the play bar is troublesome so I only do it if I am told to
const string UPDATEPLAYBAR= "update_play_bar";
//Set the number of polygons
const string NUMPOLYGONS  ="number_of_polygons";
//Set basic file information
const string FILEINFO     = "file_information";
//This sets an atoms color (ATOMCOLOR Atomtype Atomcolor)
const string ATOMCOLOR    = "color";
//These set what you scale on, your current position or the orgin
const string SCALEORIGIN  = "scale_origin";
const string SCALEPOS     = "scale_position";
//Return to orgin
const string GOTOORIGIN   = "goto_origin";
//Set the orgin
const string SETORIGIN    = "set_origin";
#endif
