#include <dtk.h>
#include "FlexArrayTmpl.H"
#include "ReadAtomFiles.hh"
#include "SharedAtoms.h"

//Look at the header file for information on these functions
//This is a really really simple class 
int DTKSharedAtoms::WriteToSharedMem()
{
	*(Changed)=true;
	FileData->getAtoms(Index, *Data);
	return 0;
}
int DTKSharedAtoms::WriteToSharedMem(const float& Time)
{
	*(Changed)=true;
	if (Time >= Begin && Time <= Finish);
	FileData->getAtoms(Time, *Data);
	return 0;
}

//Read in the atom data from disk and setup the necessary operations to make it available
DTKSharedAtoms::DTKSharedAtoms(char* SharedMemFileName, char* BaseName, const int& Start, const int& End, FlexArray<AtomDef>& TheAtoms, bool& Change)
{
	Changed = &Change;
	Index = 0;
	//Create a new TimeAtomList that contains all of the atoms
	FileData = new TimeAtomList(BaseName, Start, End);
	//Find out how many files we have to deal with
	FileData->getRange(Begin, Finish);
	printf("Created the time list ok\n");
	//Get one of the files out to determine the size of shared memory
	Data = &TheAtoms;
	printf("Before getting the data out\n");
	FileData->getAtoms(0, *Data); //Get the data out
	printf("After getting the data out\n");
}

DTKSharedAtoms::~DTKSharedAtoms()
{
	delete FileData;
}
