#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <dpf.h>
#include <dtk.h>
#include <Performer/pf.h>
#include <Performer/pf/pfGeode.h>
#include <string>
using namespace std;
#include "AtomCommands.h"
#include "FlexArrayTmpl.H"
#include "ReadAtomFiles.hh"
#include "SharedAtoms.h"
#include "CommandParser.h"
#include "Messenger.h"
#include "colorhandler.h"
#include "atomview.h"


//Initalize variables
AtomView::AtomView(char** Env)
{
	Environ=Env;

	Die = false;
	Playing = false;
	Loop = false;
	Stop = false;
	PlayRate = 1;
	DataRate = 1;
	AtomList = NULL;
	message = NULL;
	SelfMessage = NULL;
	AtomsChanged = false;
	TheScale = .1;
	WorldScale = 4;
	OldWorldScale = 4;
	WorldScaleChange = true;
	WorldSmaller = false;
	WorldLarger = false;
	NumPolygons = 10;
	OriginScale = true;
	PosScale = false;
	//We currently only support 7 different colors
	NumColors = 7;
	ColorData = new Colors[NumColors];
	for (int i=0; i<NumColors; i++)
	{
		ColorData[i].Name = new char[2];
		strcpy(ColorData[i].Name, "--");
		ColorData[i].ColorNode = NULL;
	}
	//Start position info
	x=0;
	y=0;
	z=0;
	h=0;
	p=0;
	r=0;
	OriginChange = true;
	GeoColor=NULL;
	Scaler = NULL;
	Display = NULL;
	CMap = new ColorMap[NumColors];
	for (int i=0; i<NumColors; i++)
	{
		CMap[i].Name = new char[2];
		strcpy(CMap[i].Name, "--");
		CMap[i].Color = new char[40];
	}
	//Setup the default colors for everything
	strcpy(CMap[0].Color, "blue");
	strcpy(CMap[1].Color, "red");
	strcpy(CMap[2].Color, "green");
	strcpy(CMap[3].Color, "yellow");
	strcpy(CMap[4].Color, "orange");
	strcpy(CMap[5].Color, "white");
	strcpy(CMap[6].Color, "purple");
	NumAtoms =0;
	AtomNames =NULL;
	NumAtomNames = 0;
	MaxAtoms=0;
}


//Cleanup, yes some programmers know how to make thier code cleanup after itself, or attempt to make it seem like they are!
AtomView::~AtomView()
{
	printf("Destroying the atomview data program.  Thank you for using Atomview !!!!!!!!!!!!!!!!\n");
	if (GeoColor !=NULL)
		delete GeoColor;
	if (SelfMessage != NULL)
		delete SelfMessage;
	if (AtomList != NULL)
		delete AtomList;
	for (int i=0; i<NumColors; i++)
	{
		if (ColorData[i].Name != NULL)
			delete [] ColorData[i].Name;
	}
	delete AtomList;
}
