#ifndef colorhandler_h
#define colorhandler_h
//Written to abstract making geodes of different colors
//Creates a class w/ 7 geodes of different colors in it
//Basically has a get method that gets geode pointers out 
//based on color
class ColorHandler
{
	public:
	//Comes with 7 colors by default!
	//Red, blue, green, yellow, orange, white, purple
	ColorHandler(const int& NumPolygons);
	~ColorHandler();
	//Return a pointer to the color you want 
	pfGeode* GetColor(char* Color);
	void AddColor(const char* const Name, const double& r, const double& b, const double& g);
	private:
	//Performer vodoo for making spheres
	//Rather a lot of stuff for a colored sphere huh?
	pfGeode** TheGeodes;
	pfGeoSet** TheGeoSets;
	char**    TheNames;
	pfGeoState* TheGState;
	pfMaterial* TheMaterial;
	pfVec4**   TheColors;
	int NumColors;
};
#endif
