// generated by Fast Light User Interface Designer (fluid) version 1.0011

#include "navgui.h"
#include <dtk.h>
#include <string>
using namespace std;
#include "AtomCommands.h"
#include "CommandParser.h"
#include "Messenger.h"

//Nasty external variables we are NEVER supposed to use !
Fl_Slider *WorldScaleSlider=(Fl_Slider *)0;

Fl_Slider *PositionSlider=(Fl_Slider *)0;

Fl_Box *scaleatomslabel=(Fl_Box *)0;

Fl_Output *scalemodelsize=(Fl_Output *)0;

Fl_Box *scaleworldlabel=(Fl_Box *)0;

Fl_Output *scaleworldsize=(Fl_Output *)0;

Fl_Box *positionslider=(Fl_Box *)0;

Fl_Output *position=(Fl_Output *)0;

Fl_Slider *AtomScaleSlider=(Fl_Slider *)0;

Fl_Round_Button *playbutton=(Fl_Round_Button *)0;

Fl_Round_Button *stopbutton=(Fl_Round_Button *)0;

Fl_Round_Button *loopbutton=(Fl_Round_Button *)0;

Fl_Button *returnorgin=(Fl_Button *)0;

Fl_Button *ReturnButton=(Fl_Button *)0;

Fl_Round_Button *orginscalebutton=(Fl_Round_Button *)0;

Fl_Round_Button *scaleonposition=(Fl_Round_Button *)0;


//Function prototypes and *gasp* global variables
void UpdatePlayBar();
//Used to create the window
int CreateWindow();
//The main window
Fl_Window* MainWindow;
//Do we need to stop the window
bool Running;
//Message sender
Messenger* NewMessage;
//Message Receiver
CommandParser*  Receiver;
//Used to get commands from the Receiver
string Command;
//Used for comparison
string OldCommand;
// Used so I don't create a string every time I call a function
string Blah;
char** Environ;
void Play();

//This is the function that updates the position of the play bar if it needs to be updated!
//This could easily be modified to allow for continuous updating of widgets if needbe
void UpdatePlayBar()
{
	//Get a command
	Receiver->getCommand(Command, Blah);
	//If it is repeated, return
	if (Command == OldCommand && OldCommand != UPDATEPLAYBAR)
		return;
	else
		OldCommand = Command;
	printf("In updating the play bar I have %s\n", Command.c_str());
	//Stop the gui and update the widgets
	if (Command == STOP)
	{
		playbutton->value(0);
		stopbutton->value(1);
		loopbutton->value(0);
		return;
	}
	//Update the play bar via  some fun code
	if (Command == UPDATEPLAYBAR)
	{
		printf("Before updating the play bar\n");
		double Pos = Receiver->getDouble();
		printf("Data is %lf\n", Pos);
		printf("After\n");
		if (Pos != -1 && (int)Pos != (int)PositionSlider->value())
		{
			printf("Updating bar to %lf\n", Pos);
			PositionSlider->value(Pos);
			char* Buff = new char[50];
			sprintf(Buff, "%lf", PositionSlider->value());
			position->value(Buff);
			delete [] Buff;
			printf("Bar update done\n");
		}
	}
}

//Below are the callbacks (i.e. what happends when you press on a widget
//These are rather nasty and deal w/ fltk a lot
//Unless you want to look at fltk code don't read any further.
//
//Your still reading?  Ok, what I basically do is send a message
//to dtkshared memory that tells the main atomview class what to do
//when a widget is pressed.  By doing this with message passing I 
//make the program modular so it can be called by any type of gui / other method
static void worldslidercallback(Fl_Widget*, void*)
{
	 char* Buff = new char[50];
	 double Value = WorldScaleSlider->value();
	 if (Value == 0) Value = .1;
	 sprintf(Buff, "%lf", Value);
	 scaleworldsize->value(Buff);
	if (Running)
	{
	 string Temp = WORLDSCALE;
	 Temp = Temp + "\t" + string(Buff);
	 NewMessage->SendCommand(Temp);
	}
	 delete [] Buff;
}
static void playslidercallback(Fl_Widget*, void*)
{
	 char* Buff = new char[50];
	 sprintf(Buff, "%lf", PositionSlider->value());
	 position->value(Buff);
	if (Running)
	{
	 string TempCommand = READTIME;
	 TempCommand = TempCommand + "\t" + string(Buff);
	 printf("Sending command %s\n", TempCommand.c_str());
	 NewMessage->SendCommand(TempCommand);
	}
	 delete [] Buff;
}
static void atomslidercallback(Fl_Widget*, void*)
{
	 char* Buff = new char[50];
	 double Value = AtomScaleSlider->value();
	 if (Value == 0) Value = Value + .0001;
	 sprintf(Buff, "%lf", Value);
	 scalemodelsize->value(Buff);
	if (Running)
	{
	 string TempCommand = MODELSCALE;
	 TempCommand = TempCommand + "\t" + string(Buff);
	 NewMessage->SendCommand(TempCommand);
	}
	 delete [] Buff;

}
static void diecallback(Fl_Widget*, void*)
{
	printf("Running set to false\n");
	 Running = false;
	 NewMessage->SendCommand(STARTNAV);
	 printf("DYING\n");
	 exit(1);
}

static void playcallback(Fl_Widget*, void*)
{
	NewMessage->SendCommand(PLAY);
	if (playbutton->value() == 1)
	{
		stopbutton->value(0);
		int pid = fork();
		if (pid != 0)
		{
			printf("The parent is returning\n");
			return;
		}
		else
		{
			printf("Starting play program\n");
			char* PlayProg[2];
			PlayProg[0]="play";
			PlayProg[1]=NULL;
			execve(PlayProg[0], PlayProg, Environ);
		}
	}
	else
		playbutton->value(1);
}

static void stopcallback(Fl_Widget*, void*)
{
	if (playbutton->value() == 1)
	{
		NewMessage->SendCommand(STOP);
		playbutton->value(0);
		loopbutton->value(0);
	}
	else
		stopbutton->value(0);
}

static void loopcallback(Fl_Widget*, void*)
{
	NewMessage->SendCommand(LOOP);
}
static void returnorgincallback(Fl_Widget*, void*)
{
	printf("Returning to the original position\n");
	//NewMessage->SendCommand(STARTNAV);
	NewMessage->SendCommand(GOTOORIGIN);
	//NewMessage->SendCommand(STOPNAV);
}

static void scaleonorgincallback(Fl_Widget*, void*)
{
	printf("Scaling on orgin\n");
	NewMessage->SendCommand(SCALEORIGIN);
	scaleonposition->value(0);
}

static void scaleonposcallback(Fl_Widget*, void*)
{
	printf("Scaling on position \n");
	NewMessage->SendCommand(SCALEPOS);
	orginscalebutton->value(0);
}

//Create a fltk window and loop through while it is running(displaying)
int main(int argc, char** argv, char** env)
{
	Environ = env;
	NewMessage = new Messenger("ATOM_MESSAGE");
	Receiver = new CommandParser("ATOM_MESSAGE");
	Command = "";
	CreateWindow();
	while (Running)
	{
		MainWindow->visible_r();
		UpdatePlayBar();
		Fl::wait(.00000000000000000000000000000000000000000000000000000000000000005);
		usleep(1);
	}
	return 0;
}


//Fluid code modified to hold callbacks and to set the max position of the  world scale slider
//Create the fltk window and setup the callbacks, thank God for fluid I would hate
//to have to write all this by hand
//On the creation of the play slider this goes through and gets its state from shared memory
//And based on that state brings all the sliders to the right value, updates all the data boxes, etc...
int CreateWindow() {
  Fl_Window* w;
  { Fl_Window* o = MainWindow = new Fl_Window(271, 317);
    w = o;
    { Fl_Slider* o = WorldScaleSlider = new Fl_Slider(0, 100, 270, 25);
      o->type(1);
      o->maximum(8);
      o->step(.1);
      o->align(FL_ALIGN_RIGHT);
      o->callback(worldslidercallback, NULL);
      o->value(4);
    }
    { Fl_Round_Button* o = loopbutton = new Fl_Round_Button(205, 255, 65, 35, "Loop");
      o->down_box(FL_ROUND_DOWN_BOX);
      o->selection_color(0);
      o->callback(loopcallback, NULL);
    }
    ReturnButton = new Fl_Button(125, 290, 145, 25, "Close menu");
    ReturnButton->callback(diecallback, NULL);
    scaleatomslabel = new Fl_Box(10, 10, 85, 25, "Scale Atoms");
    scalemodelsize = new Fl_Output(170, 5, 100, 25);
    scaleworldlabel = new Fl_Box(10, 75, 85, 25, "Scale World");
    scaleworldsize = new Fl_Output(170, 70, 100, 25);
    positionslider = new Fl_Box(10, 195, 85, 25, "Atoms at time");
    position = new Fl_Output(170, 195, 100, 25);
    { Fl_Slider* o = AtomScaleSlider = new Fl_Slider(0, 35, 270, 25);
      o->type(1);
      o->maximum(1);
      o->step(.01);
      o->align(FL_ALIGN_RIGHT);
      o->callback(atomslidercallback,NULL);
      o->value(.01);
    }
    { Fl_Round_Button* o = playbutton = new Fl_Round_Button(0, 255, 55, 35, "Play");
      o->down_box(FL_ROUND_DOWN_BOX);
      o->selection_color(60);
      o->callback(playcallback, NULL);
    }
    { Fl_Round_Button* o = stopbutton = new Fl_Round_Button(110, 255, 55, 35, "Stop");
      o->down_box(FL_ROUND_DOWN_BOX);
      o->selection_color(88);
      o->callback(stopcallback, NULL);
    }
    returnorgin = new Fl_Button(0, 290, 125, 25, "Return to start");
    returnorgin->callback(returnorgincallback, NULL);
    { Fl_Round_Button* o = orginscalebutton = new Fl_Round_Button(0, 125, 40, 35, "Scale on orgin");
      o->down_box(FL_ROUND_DOWN_BOX);
      o->type(102);
      o->selection_color(0);
      o->align(FL_ALIGN_RIGHT);
      o->callback(scaleonorgincallback, NULL);
    }
    { Fl_Round_Button* o = scaleonposition = new Fl_Round_Button(0, 155, 40, 35, "Scale on current position");
      o->down_box(FL_ROUND_DOWN_BOX);
     // o->color(0);
      o->type(102);
      o->selection_color(0);
      o->align(FL_ALIGN_RIGHT);
      o->callback(scaleonposcallback, NULL);
      o->value(1);
    }
    { Fl_Slider* o = PositionSlider = new Fl_Slider(0, 220, 270, 25);
	    //This is a complex creation function because it basically queries the main atomview program and sets all of the values based on what they are in the atomview program
	double MaxPos = 0;
	NewMessage->SendCommand(GETINFO);
	Command = "";
	Receiver->getCommand(Command, CLASS_TYPE);                    
       	while ( Command != INFOIS)
	{  
		Receiver->getCommand(Command, CLASS_TYPE);  
		//printf("Waiting on my command %s\n", Command.c_str());  
		usleep(1000); 
	}    
	printf("Found my command\n");
	//The Play rate
	MaxPos = (int)Receiver->getDouble();                          
	//The data rate
	MaxPos = (int)Receiver->getDouble();
	//The current position
	MaxPos = (int)Receiver->getDouble();  
	PositionSlider->value(MaxPos);
	//The Ending position
	MaxPos = (int)Receiver->getDouble();   
        o->maximum(MaxPos);
	//Whether or not we are looping
	MaxPos = (double)Receiver->getInt();
	if ((int)MaxPos)
		loopbutton->value(1);
	else
		loopbutton->value(0);
	//Check to see if we are playing 
	MaxPos= (double)Receiver->getInt();
	if ((int)MaxPos)
		playbutton->value(1);
	else
		playbutton->value(0);
	//Set the stop button
	MaxPos= (double)Receiver->getInt();
	if ((int)MaxPos)
		stopbutton->value(1);
	else
		stopbutton->value(0);
	//Set if we scale on the orgin or not
	MaxPos= (double)Receiver->getInt();
	if ((int)MaxPos)
		orginscalebutton->value(1);
	else
		orginscalebutton->value(0);
	//Set if we are scaling based on the users position
	MaxPos= (double)Receiver->getInt();
	if ((int)MaxPos)
		scaleonposition->value(1);
	else
		scaleonposition->value(0);
	//Set the scale of the world slider
	MaxPos= Receiver->getDouble();
	WorldScaleSlider->value(MaxPos);
	//Set the scale of the atoms slider
	MaxPos= Receiver->getDouble();
	AtomScaleSlider->value(MaxPos);

      o->type(1);
      o->step(1);
      o->align(FL_ALIGN_RIGHT);
      o->callback(playslidercallback, NULL);
      //Update the value boxes
      playslidercallback(NULL, NULL);
      worldslidercallback(NULL, NULL);
      atomslidercallback(NULL, NULL);
      Running = true;
    }
    o->end();
  }
  w->position(-1,-1);
  w->show();
  return 0;
}
