#include <dtk.h>
#include "Messenger.h"
#include "CommandParser.h"
#include "AtomCommands.h"


int main()
{
	printf("Starting to play with the correct player\n");
	string Command = "";
	//Setup message passing info
	Messenger* PlayMessage = new Messenger("ATOM_MESSAGE");
	CommandParser* PlayParse = new CommandParser("ATOM_MESSAGE");
	string PlayCommand = "";
	//Get the state information from the main process
	PlayMessage->SendCommand(GETINFO);
	PlayParse->getCommand(PlayCommand, CLASS_TYPE);
	while (PlayCommand != INFOIS)
	{
		printf("NOT GETTING THE RIGHT COMMAND :( %s\n", Command.c_str());
		//NewMessage.SendCommand(GETINFO);
		PlayParse->getCommand(PlayCommand, CLASS_TYPE);
		usleep(10000);
	}
	//Get info out of the message
	double PlayRate = PlayParse->getDouble();
	double DataRate = PlayParse->getDouble();
	double AStart   = PlayParse->getDouble();
	double End      = PlayParse->getDouble();
	int Looping =     PlayParse->getInt();
	printf("Starting to play with prate = %lf drate=%lf , starting pposition %lf , ending position %lf, and %d is the loop data\n", PlayRate, DataRate, AStart, End, Looping);
	//Create a new clock and set it to the
	dtkTime* Time = new dtkTime(); 
	//Stop if we are at the end already
	if(AStart == End)
	{
		PlayMessage->SendCommand(STOP);
		return 1;;
	}
	//How long has the loop taken
	long double Elaspedtime = 0;
	//Number of writes each file gets
	//int NumWrites = 0;
	string ACommand;
	//What is our time?
	double TheTime = 0;
	//What position do we spit to memory?
	float Increment;
	//Are we repeating
	bool Loop = (int)Looping;
	//How long have we spent on doing this?
	long double TotalTime = 0;
	//Set the beginning time
	Time->get();
	//Basically figure out  what each write needs to be and then sleep until I'm supposed to do the next write
	while (1)
	{
		//Set start time	
		Time->delta();
		//Where am I going in the data list next?
		Increment = (AStart + TheTime * PlayRate);
		//Handle messages
		for (int i=0; i<10; i++)
		{
			PlayParse->getCommand(ACommand, CLASS_TYPE); 
			if (ACommand == STOP || ACommand == DIE)
			{
				printf("I got the stop command\n");
				delete Time;
				exit(1);
			}
			if (ACommand == LOOP && !Loop)
			{
				Loop=true;
				printf("Loop is on\n");
			}
			else if (ACommand == LOOP && Loop)
			{
				printf("Loop is off\n");
				Loop=false;
			}
			ACommand="";
		}
		//Check to see if we are at the end of list
		if (Increment >= End + 1)
		{
			if (Loop)
			{
				Increment  = 0;
				AStart = 0;
			}
			else
			{
				PlayMessage->SendCommand(STOP);
				delete Time;
				return 1;
			}
		}
		//If we are at the over one second mark do some calcs/ resets and then go on
		if (TheTime >= 1)
		{
			printf("*********%lf second finished*****************\n", (double)TotalTime);
			TotalTime = TotalTime + TheTime;
			printf("TTime %lf time %lf\n", (double)TotalTime, (double)TheTime);
			printf("Writing at %lf\n", Increment);
			if (Increment !=0)
			AStart = AStart + TheTime*PlayRate;
			else
				AStart = 0;
			TheTime = 0;
		}
		//Update the time
		TheTime = TheTime + DataRate;
	  	//Begin update 1 and send the goto time *** to shared memory by building a message in shared memory	
		char *Buff = new char[200];
		sprintf(Buff, "%s\t%f", READTIME.c_str(), Increment);
		printf("Writing %s to shared memory\n", Buff);
		PlayMessage->SendCommand(string(Buff));
		delete [] Buff;
		//End update 1
		//Begin update 2 send update the play bar to position *** 
		Buff = new char[200];
		sprintf(Buff, "%s\t%f", UPDATEPLAYBAR.c_str(), Increment);
		printf("Writing %s to shared memory\n", Buff);
		PlayMessage->SendCommand(string(Buff));
		delete [] Buff;
		//End update 2
		//Now figure out how much time we need to sleep (dtkTime is an awesome class)
		Elaspedtime = Time->get();
		if (Elaspedtime < DataRate)
			usleep((int)((DataRate- Elaspedtime) * (1000000)));// -100000));
	}
}
